utility utlkbc " KeyBip-Control V1.0"
(
 button opnwndw "Open KeyBip"
 on opnwndw pressed do
( 
  global keycontrolroll--roll
  global biptransformx
-----------------------------------------------------------------------------------------------------------------
try ( destroydialog keycontrolroll ) catch ()
rollout keycontrolroll " KeyBip-Control V1.0"
( 
  local kcb
---------------------------------------------------------
group "TCB Type" 
 (  
  spinner EaseTobip "Ease To :"  offset:[12,0] width:85 height:16  type:#float fieldwidth:40 range:[0.0,50.0,0.0] align:#center
  spinner EaseFrombip "Ease From :"  offset:[12,-3] width:85 height:16  type:#float fieldwidth:40 range:[0.0,50.0,0.0] align:#center
  spinner tensbip "Tension :"  offset:[12,1] width:85 height:16  type:#float fieldwidth:40 range:[0.0,50.0,25.0] align:#center
  spinner contibip "Continuity :"  offset:[12,-3] width:85 height:16  type:#float fieldwidth:40 range:[0.0,50.0,25.0] align:#center
  spinner biasbip "Bias :"  offset:[12,-3] width:85 height:16  type:#float fieldwidth:40 range:[0.0,50.0,25.0] align:#center
 )
group "" 
 ( 
   button GoPrevc "<<" width:32 height:18 offset:[-5,-10] align:#left tooltip:"Click: PREVIOUS SET | Click-CTRL: PREVIOUS keys"  across:3 --images:#("ui\icons\VCRControls_16i.bmp", undefined , 28, 3,3,3,3)
   button Goset "SET" width:45 height:18 offset:[0,-10] align:#center tooltip:"GO SET"
   button Gonextc ">>" width:32 height:18 offset:[7,-10] align:#right tooltip:"Click: NEXT SET | Click-CTRL: NEXT keys" --images:#("ui\icons\VCRControls_16i.bmp", undefined, 28, 11,11,11,11)


   Label Qprog "Progess" offset:[0,0]
   progressbar batch_prog color:red -- a red progress bar
   button batchset "BATCH   SET" width:115 height:18 offset:[0,2] align:#center tooltip:"AUTO BATCH SET" --images:#("ui\icons\VCRControls_16i.bmp", undefined, 28, 11,11,11,11)
 )
	button defaultctrl "Default  Setting" height:20 width:80 offset:[0,0]  tooltip:"Default Setting" align:#left  across:2
	button btnhelp "?" height:20 width:20 offset:[0,0]  tooltip:"HELP Note" align:#right 

--------------------------------------------------------
on btnhelp pressed do
	(   outside_string = "\n"
        outside_string = "- Global Adjust Keys set TCB Controller for Biped Object ( Tested in max 7 and 8)\n\n" 
		outside_string += "- U can set by Manual button or Auto Batch set... !\n\n"
		outside_string += "Budi Gunawan -- March 2006\n" 
		outside_string += "gunaone77@yahoo.com\n"		
		messagebox outside_string title: " NOTES - KeyBip-Control V1.0"
	)
--------------------------------------------------------
on defaultctrl pressed do 
(
  EaseTobip.value = 0.0
  EaseFrombip.value = 0.0
  tensbip.value = 25.0
  contibip.value = 25.0
  biasbip.value = 25.0
  Qprog.text = "Progess"
  format (" \n")
  max motion mode
)

fn spinervalbip =
(
     kcb.easeTo = EaseTobip.value --Float Default: 0.0
     kcb.easeFrom = EaseFrombip.value --Default: 0.0
     kcb.continuity = contibip.value -- Float Default: 25.0
     kcb.tension = tensbip.value --Float Default: 25.0
     kcb.bias = biasbip.value --Float Default: 25.0
)

fn BIPBrutalsetx =
(  undo "Batch Set Key-Info" on ( 
  setWaitCursor();
  framenumber = slidertime.frame as integer ----(currentTime as integer)/TicksPerFrame
  kb = biptransformx.keys
  datakeyb = numKeys biptransformx
  if datakeyb == 0 then ( Qprog.text = "0 Keys Bip. No set !!" ;) else ( Qprog.text = "Please Wait !!" ;
   for tm in kb do 
    (--for
      bt = tm.time -- info frame/key
      slidertime = bt -- move slider time
 
      num_index = getKeyIndex biptransformx bt -- get Key Index
      kcb = biped.getKey biptransformx num_index -- get Key
      ----------------
      spinervalbip ()
      ----------------
	  batch_prog.value = 100.*bt/num_index
    )--for
     Qprog.text = ((datakeyb as string) +" Keys .Done !!") ;
     slidertime = framenumber
     batch_prog.value = 0
   ))
)
fn executeBATCHbiproot = --junk
(--
  try (
       if $.transform.controller.trackSelection == 1 then  ( biptransformx = $.transform.controller.horizontal.controller 
          BIPBrutalsetx()
       ) else (
               if $.transform.controller.trackSelection == 2 then ( biptransformx = $.transform.controller.vertical.controller 
                  BIPBrutalsetx()
                ) else (
                        if $.transform.controller.trackSelection == 3 then ( biptransformx = $.transform.controller.turning.controller 
                        BIPBrutalsetx() 
				       )
              )
         )
      ) catch ( biptransformx = $.controller
	            BIPBrutalsetx () 
	          )
)--
----------------------------------------------------------------------------------------------------------------------------
fn setbiproot =
(
  framenumber = slidertime.frame as integer ----(currentTime as integer)/TicksPerFrame
  num_indexROOT = getKeyIndex biptransformx framenumber
   if num_indexROOT == 0 then (format "Oops, No keys !\n"; Qprog.text = "Oops, No keys !") else (
-----------------------------------
           FrmStart = animationRange.start
           FrmEnd = animationRange.end

           deselectKeys biptransformx (interval FrmStart  FrmEnd) -- deselect key in track
           selectKey biptransformx num_indexROOT -- select key on slidertime

           kcb = biped.getKey biptransformx num_indexROOT -- get Key
      ----------------
      spinervalbip ()
      ----------------
    format "Set-Up...Done !!\n")
)

fn executebiproot = --junk
(--
  try (
       if $.transform.controller.trackSelection == 1 then  ( biptransformx = $.transform.controller.horizontal.controller 
          setbiproot()
       ) else (
               if $.transform.controller.trackSelection == 2 then ( biptransformx = $.transform.controller.vertical.controller 
                  setbiproot()
                ) else (
                        if $.transform.controller.trackSelection == 3 then ( biptransformx = $.transform.controller.turning.controller 
                        setbiproot() 
				       )
              )
         )
      ) catch ( biptransformx = $.controller
                setbiproot() 
			   )
)--
--88888888888888888888888888888888888888888888
on keycontrolroll open do ( max motion mode )--do
on keycontrolroll close do ( format "\n" )--do
---------------------------------------------
		on GoPrevc pressed do
		(--do
			if keyboard.controlPressed then 
			( 
				nt = trackbar.getPreviousKeyTime()
				if nt != undefined then sliderTime = nt
			)
			else
			(
             if selection.count == 1 and classof $ == Biped_Object then (
				nt = trackbar.getPreviousKeyTime()
				if nt != undefined then sliderTime = nt
				executebiproot ()
		        ) else (  messagebox "Please select least 1 Biped Object !" )
			)
		)--do
		on GoNextc pressed do
		(--do
			if keyboard.controlPressed then
			( 
				nt = trackbar.getNextKeyTime()
				if nt != undefined then sliderTime = nt
			)
			else
			 (
             if selection.count == 1 and classof $ == Biped_Object then (
				nt = trackbar.getNextKeyTime()
				if nt != undefined then sliderTime = nt
				executebiproot ()
		        ) else (  messagebox "Please select least 1 Biped Object !" )
			 )
		)--do
 on Goset pressed do
  (--do
		if selection.count == 1 and classof $ == Biped_Object then executebiproot ()
		 else ( messagebox "Please select least 1 Biped Object !" )
  )--do
  
 on batchset pressed do 
  (--do
     if selection.count == 1 and classof $ == Biped_Object then 
                ( try (  undo "Set Key-Info" on (
				        mex = $
                        max select invert  -- invert selection
                        junkobj = getcurrentselection ()
                        select mex
                        hide junkobj
						executeBATCHbiproot ()
			            unhide junkobj
				        redrawViews()) ) catch ()
                ) else (  messagebox "Please select least 1 Biped Object !" )
  )--do
)
createdialog keycontrolroll 130 255 380 280 style:#(#style_sysmenu, #style_toolwindow))
)